
from omero.gateway import BlitzGateway
import omero
from omero.rtypes import rdouble, rstring, rint
from omero.model.enums import UnitsLength

conn = BlitzGateway('user', 'password')
conn.connect()

image = conn.getObject("Image", 8552)


updateService = conn.getUpdateService()

for core_id in [1, 2]:

    # add one new rectangle ROI
    x = 100 * core_id
    y = 100 * core_id
    width = 50
    height = 50
    theZ = 0
    theT = 0

    # create an ROI, link it to Image
    roi = omero.model.RoiI()

    # use the omero.model.ImageI that underlies the 'image' wrapper
    roi.setImage(image._obj)

    # create a rectangle shape and add to ROI
    rect = omero.model.RectI()
    rect.x = rdouble(x)
    rect.y = rdouble(y)
    rect.width = rdouble(width)
    rect.height = rdouble(height)
    rect.theZ = rint(theZ)
    rect.theT = rint(theT)
    rect.textValue = rstring(str(core_id))

    ## problem occurs in java client 5.1.2 Ice35 b45,
    ## when the following lines are uncommented,
    ## web viewer is ok
    rect.strokeColor = rint(0xff0000)
    strokeWidth = omero.model.LengthI(5, UnitsLength.PIXEL)
    rect.strokeWidth = strokeWidth
    fontSize = omero.model.LengthI(50, UnitsLength.PIXEL)
    rect.fontSize = fontSize

    roi.addShape(rect)

    # Save the ROI (saves any linked shapes too)
    r = updateService.saveAndReturnObject(roi)
